	nolist
ystone	macro
	nolist
; pck v9 r 2
; trigger s&t board used only once
; 
; sets cli / sei
; uses x0032 / x0034 and swsound ( 4 bit variable)
;
	jmp	ysndre
;
;
; decrease sound disable timer during interrupt
;
ysnddi:
	ldaa	X0034	; sound disable time
	beq	ysnddi9
	ldab	XMATCHC
	bitb	#$03
	bne	ysnddi9
	deca
	staa	X0034	; sound disable time
	bne	ysnddi9
	clr	swsound	; ; pending sound command
ysnddi9:
	rts
	
; first time routine for sound...
;
ysndr	equ  	*
;	a holds soundcmd
; 	b holds delay after soundcmd
	stab 	X0032	; save for b
	ldab	swsound	; pending sound command
	bmi	ysnddi9
	ldab	pu11BC
	andb	#$08
	bne	ysndr2
ysndr1:
	ldab	pu11B0
	orab	#$F0
	comb
	bne	ysndr1
ysndr2:
	sei
	ldab	#$0F
	orab	pu11B0
	stab	pu11B0
	ldab	#$34
	stab	pu11BC
	psha
	pula
	psha
	anda	#$0F
	ldab	#$3C
	stab	pu11BC
	ldab	pu11B0
	andb	#$F0
	aba
	staa	pu11B0
	ldab	#$08
ysndr3:
	decb
	bne	ysndr3
	pula
	lsra
	lsra
	lsra
	lsra
	ldab	pu11B0
	andb	#$F0
	aba
	staa	pu11B0
	ldab	#$06
ysndr4:
	decb
	bne	ysndr4
	cli
	ldaa	X0032
	beq	ysndr5
	com	swsound	; pending sound command
	staa	X0034	; sound disable time
ysndr5:
	ldab	#$01
	jmp	ywaitb 	; wait 1f reduced b times by irq
ysndre	equ	*
	list
	endm
yst	macro	scmd,sdel,save
;
; trigger s&t board
;
; if scmd empty reg a is used
; if del empty reg b is used
; if save filled a and b pushed stack
; sets cli / sei
; uses x0032 / x0034 and swsound ( 4 bit variable)
;
	if      '\3' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$scmd
	nolist
	endif
	if      '\2' != ''
	list
	ldab	#$sdel
	nolist
	endif
	list
	jsr	ysndr
	nolist
	if      '\3' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
	list