	nolist
ystone	macro
	nolist
; pck v10 r1
; trigger soundcard 32 / -50 used in harlem use only once this macro
; 
; sets cli / sei
; soundcard 32 / -50 used in harlem
; uses x0030,x0032,X033,x0034
; x0030 first byte of soundcmd
; X0032 / X0033 save actual position reg x
; x0034 work variable for zero cross...
; start sound with soundcmd in X
; look at adr X
; $nn $mm $oo $pp
; store first byte in x0030
; if x0030 = 1XXX XXXX sound is played sync, XXX XXX holds wait time between sound
; if x0030 = 0XXX XXXX sound is played in async, XXX XXX holds wait time between sound (decreased by zero cross )
; loop
; increase x until contest of xx eq FF -> Sound cmd finished; break
; increase x until contest of xx eq 00 -> refill X0030, go to loop
; otherwise play sound (5 bits relevant)
; if sound should be in sync go to loop until end
; if sound  should be in assync copy x0030 -> X0034 and save X in X0032 / X0033, then routine is called again by zero cross if X0034 reaches zero
;
	jmp	ysndre
;
;
;

ysn56:           ; Make Sound (Dataadress X)
	clr	X0034
ysn5B:
	ldaa	$00,x
	staa	X0030
ysn5F:			; Make Sound Loop
	inx
	ldaa	$00,x
	cmpa	#$FF
	beq	ys5AE
	tsta
	bne	ysn6C
	inx
	bra	ysn5B
;
ysn6C:			
	ldab	pu11BC
	andb	#$08
	bne	ysn79
	ldab	pu11B0
	orab	#$F0
	comb
	bne	ysnA6
ysn79:
	ldab	#$FD
	sei
	andb	pu11A0
	asla
	bcs	ysn83
	orab	#$02
ysn83:
	stab	pu11A0
	tsta
	bmi	ysn97
	ldab	#$0F
	orab	pu11B0
	stab	pu11B0
	ldab	#$34
	stab	pu11BC
	ldab	#$09
ysn94:
	decb
	bne	ysn94
ysn97:
	lsra
	anda	#$0F
	ldab	#$3C
	stab	pu11BC
	ldab	pu11B0
	andb	#$F0
	aba
	staa	pu11B0
	cli
ysnA6:
	ldab	X0030
	bmi	ysnB4
	stx	X0032
	stab	X0034
ys5AE:
	rts
;
;
ysnB4:
	andb	#$7F
	jsr	ywaitb	; wait 1f reduced b times by irq (PCK)
	bra	ysn5F
;
ysnddi:          ; called during zerocross 
	ldaa	X0034
	beq	ysnddi9
	deca
	staa	X0034
	bne	ysnddi9
	ldx	X0032
	bsr	ysn5F
ysnddi9:
	rts
ysndre	equ	*
	list
	endm
yst32	macro	save
;
; trigger soundcard 32 / -50 used in harlem
;
; use index register X
; if save filled a and b pushed stack
; sets cli / sei
; uses x0030,x0032,X033,x0034
;
	if      '\1' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	list
	jsr	ysn56
	nolist
	if      '\1' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
	list
